
-- exhaustively get reagents of reagents using scanned data
function CraftBot_RefineScan()
	isScanning = true
	for i=1, #(CraftBot_Data) do
		for x=1,#(CraftBot_Data[i].skills) do
			for y=1,#(CraftBot_Data[i].skills[x].data) do
				CraftBot_Debug("TS: " .. CraftBot_Data[i].skills[x].data[y].craftLink)
				repeat
					local refine = false
					local newReagentData = {}
					for z=1,#(CraftBot_Data[i].skills[x].data[y].reagents) do
						local reagentData = CraftBot_GetReagentReagentData(CraftBot_Data[i].skills[x].data[y].reagents[z][LINK])
						if #(reagentData) > 0 then
							local oldReagent = CraftBot_Data[i].skills[x].data[y].reagents[z]
							for j=1, #(reagentData) do
								--reagentData[j][QTY] = reagentData[j][QTY] * oldReagent[QTY]
								CraftBot_Debug("qty: " ..oldReagent[QTY])
								tinsert(newReagentData, reagentData[j])
							end
							refine = true
						else
							tinsert(newReagentData, CraftBot_Data[i].skills[x].data[y].reagents[z])
						end
					end
					CraftBot_Data[i].skills[x].data[y].reagents = newReagentData
				until not refine
			end
		end
	end
	isScanning = false
end

function CraftBot_GetReagentReagentData(link)
	for i=1, #(CraftBot_Data) do
		if CraftBot_Searchable(i) then
			for x=1,#(CraftBot_Data[i].skills) do
				for y=1,#(CraftBot_Data[i].skills[x].data) do
					if CraftBot_Data[i].skills[x].data[y].craftLink == link then
						return CraftBot_Data[i].skills[x].data[y].reagents
					end
				end
			end
			if CraftBot_Search_Mode == PLAYER then
				break
			end
		end
	end
	return {}
end
