﻿CRAFTBOT_VERSION = "1.0.9"

CRAFTBOT_MENU = "CraftBot"
CRAFTBOT_LABEL = "CraftBot's Mode: "

CRAFTBOT_ON = "CraftBot is On"
CRAFTBOT_OFF = "CraftBot is Off"
CRAFTBOT_WELCOME = "Welcome to %s\'s %s Shoppe!"
CRAFTBOT_LIMIT = "CraftBot's results limit: %d"
CRAFTBOT_RESET = "CraftBot has resetted data for "..UnitName("player")
CRAFTBOT_RESET_ALL  = "CraftBot has resetted data for all your characters"
CRAFTBOT_RESET_MSG  = "CraftBot has resetted messages"

CRAFTBOT_MENU_ENABLE = "Start"
CRAFTBOT_MENU_OPTION = "Options"
CRAFTBOT_MENU_LIMIT = "Result Limit"
CRAFTBOT_MENU_REFINE = "Refine Reagents"
CRAFTBOT_MENU_SILENT = "Silent"
CRAFTBOT_HINT = "Left-click to configure"

CRAFTBOT_WHISPERCMD = "!cb"
CRAFTBOT_WHISPERCMD_HELP = CRAFTBOT_WHISPERCMD.."help"
CRAFTBOT_WHISPERCMD_SEARCH = CRAFTBOT_WHISPERCMD.."search"
CRAFTBOT_WHISPERCMD_REAGENTS = CRAFTBOT_WHISPERCMD.."mats"
CRAFTBOT_WHISPERCMD_USE = CRAFTBOT_WHISPERCMD.."use"

CRAFTBOT_RESULT = "[%d.%d.%d] %s"
CRAFTBOT_RESULT_QTY = CRAFTBOT_RESULT .. " Qty: %s"
CRAFTBOT_RESULT_QTY2 = CRAFTBOT_RESULT_QTY .. "min/%smax"
CRAFTBOT_RESULTS_OK = "Request on '%s' by [|Hplayer:%s|h%s|h]. %d results found."
CRAFTBOT_RESULTS_NOK = "Request on '%s' by [|Hplayer:%s|h%s|h]. No result found."
CRAFTBOT_RESULTS2_OK = "Request on '%s' to [|Hplayer:%s|h%s|h]. %d results found"
CRAFTBOT_RESULTS2_NOK = "Request on '%s' to [|Hplayer:%s|h%s|h]. No result found"

CRAFTBOT_TOOLTIP_SKILL = "%s: %d"
CRAFTBOT_TOOLTIP_LOCALIZATION = {
	{"WARNING!", 1, 0, 0},
	{"Change only if you know what you are doing.", 1, 1, 1},
	{"Hint: Press ENTER to save", 0, 1, 0},
}

CRAFTBOT_TOOLTIP_LIMIT = {
	{"Sets the maximum number of results returned for each search.", 1, 1, 1},
	{"To remove limit, set to 0.", 1, 1, 1},
	{"Hint: Press ENTER to save", 0, 1, 0},
}

CRAFTBOT_SMODE_LABEL = "CraftBot's Search Mode: "
CRAFTBOT_SMODE_SILENT_LABEL = "CraftBot's Silent Mode: "
CRAFTBOT_SMODE_FACTION_LABEL = "CraftBot's Faction Mode: "
CRAFTBOT_SMODE_REFINE_LABEL = "CraftBot's Refine Reagents Mode: "
CRAFTBOT_SMODE_REFINE = "Refine Reagents"
CRAFTBOT_SMODE_PLAYER = "Player"
CRAFTBOT_SMODE_REALM = "Realm"
CRAFTBOT_SMODE_XREALM = "XRealm"
CRAFTBOT_SMODE_OFF = "Off"
CRAFTBOT_SMODE_ON = "On"
CRAFTBOT_SMODE_FACTION = "Faction"
CRAFTBOT_SMODE_SILENT = "Silent"

CRAFTBOT_SCAN_COMPLETE = "CraftBot scan completed"
CRAFTBOT_SCAN_COMPLETE_ERROR = CRAFTBOT_SCAN_COMPLETE.." with errors. Please rescan."
CRAFTBOT_SCAN_RECORDED = "%d crafts recorded"

CRAFTBOT_HELP = "Whisper me \""..CRAFTBOT_WHISPERCMD_SEARCH.."\" and part of the craft's name/desc/category (epic, felcloth, iron, consumable) e.g. \""..CRAFTBOT_WHISPERCMD_SEARCH.." %s\". Whisper me \""..CRAFTBOT_WHISPERCMD_USE.."\" and part of the reagent's name e.g. \""..CRAFTBOT_WHISPERCMD_USE.." %s\""
CRAFTBOT_HELP_MAT = "Whisper me \""..CRAFTBOT_WHISPERCMD_REAGENTS.." <number>\" e.g. \""..CRAFTBOT_WHISPERCMD_REAGENTS.." 1.2.3\"!"
CRAFTBOT_HELP_NOK = "No matches found for that query, try refining your request. Whisper me "..CRAFTBOT_WHISPERCMD_HELP.." for help."
CRAFTBOT_HELP_TOO_MANY = "There are more than %d matches, try refining your request. Whisper me "..CRAFTBOT_WHISPERCMD_HELP.." for help."

CRAFTBOT_MAT_OK = "Sending reagent list of '%s' to [|Hplayer:%s|h%s|h]."
CRAFTBOT_MAT_NOK = "Sending reagent list of '%s' to [|Hplayer:%s|h%s|h] failed."
CRAFTBOT_MAT_LIST = "Reagents for %s :"
